問題:
LeetCode-1
English:
Given an array of integers, return indices of the two numbers such that they add up to a specific target.
You may assume that each input would have exactly one solution, and you may not use the same element twice.
Example:
Given nums = [2, 7, 11, 15], target = 9,
Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].
中文:
給定一個整數(shù)數(shù)組 nums 和一個目標值 target捎琐,請你在該數(shù)組中找出和為目標值的那 兩個 整數(shù)会涎,并返回他們的數(shù)組下標。
你可以假設(shè)每種輸入只會對應一個答案野哭。但是在塔,你不能重復利用這個數(shù)組中同樣的元素。
示例:
給定 nums = [2, 7, 11, 15], target = 9
因為 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]
解法:
使用HashMap同時記錄下數(shù)字和位置拨黔,用目標數(shù)字循環(huán)去減數(shù)組內(nèi)部的數(shù)蛔溃,并遍歷哈希表看看減的結(jié)果是否已經(jīng)在哈希表內(nèi),如果在篱蝇,則可以直接輸出了贺待。
實現(xiàn)代碼(java版)
if (nums == null || nums.length < 2) {
return new int[] { -1, -1 };
}
int[] des = new int[] { -1, -1 };
HashMap<Integer, Integer> map = new HashMap<Integer, Integer>();
for (int i = 0; i < nums.length; i++) {
if (map.containsKey(target - nums[i])) {
des[0] = map.get(target - nums[i]);
des[1] = i;
break;
}
map.put(nums[i], i);
}
return des;